   This file documents the KSBA library to access X.509 and CMS data
structures.

   This is edition 1.0.1, last updated 3 November 2006, of `The KSBA
Reference Manual', for Version 1.0.1.

Main Menu
*********

This is edition 1.0.1, last updated 3 November 2006, of `The KSBA
Reference Manual', for Version 1.0.1 of the KSBA library.

   Copyright (C) 2002, 2003, 2004 g10 Code GmbH

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version. The text of the license can be found in the
section entitled "Copying".

Appendices

Indices

1 Introduction
**************

KSBA is a library to make the task of working with X.509 certificates,
CMS data and related data more easy.

1.1 Getting Started
===================

This manual documents the `KSBA' library programming interface.  All
functions and data types provided by the library are explained.

   The reader is assumed to possess basic knowledge about the
implemented protocols.

   This manual can be used in several ways.  If read from the beginning
to the end, it gives a good introduction into the library and how it
can be used in an application.  Forward references are included where
necessary.  Later on, the manual can be used as a reference manual to
get just the information needed about any particular interface of the
library.  Experienced programmers might want to start looking at the
examples at the end of the manual, and then only read up those parts of
the interface which are unclear.

1.2 Features
============

`KSBA' has a couple of advantages over other libraries doing a similar
job, and over open coding the protocols in your application directly.

It's Free Software
     Anybody can use, modify, and redistribute it under the terms of
     the GNU General Public License (see Copying).

It hides the low level stuff
     `KSBA' a high level interface to the implemented protocols and
     presents the data in a consistent way.  There is no more need to
     worry about all the nasty details of the protocols.  The API gives
     the C programmer a more usual way of interacting with the data.

It copes with the version details
     X.509 protocols tend to have many different versions and dialects.
     Applications must usually cope with all of this and it has to be
     coded over and over again.  `KSBA' hides this by providing just
     one API which does the Right Thing.  Support for new versions and
     features of the protocols will be added over time.

1.3 Overview
============

The `KSBA' library is thread-safe as long as objects described by one
context are only used by one thread at a time.  No initialization is
required.

2 Preparation
*************

To use `KSBA', you have to perform some changes to your sources and the
build system.  The necessary changes are small and explained in the
following sections.  At the end of this chapter, it is described how the
library is initialized, and how the requirements of the library are
verified.

2.1 Header
==========

All interfaces (data types and functions) of the library are defined in
the header file `ksba.h'.  You must include this in all programs using
the library, either directly or through some other header file, like
this:

     #include <ksba.h>

   The name space of `KSBA' is `ksba_*' for function names, `ksba*' for
data types and `KSBA_*' for other symbols.  In addition the same name
prefixes with one prepended underscore are reserved for internal use
and should never be used by an application.

2.2 Version Check
=================

It is often desirable to check that the version of `KSBA' used is indeed
one which fits all requirements.  Even with binary compatibility, new
features may have been introduced but through peculiarities of the
runtime linker an old version gets actually used.  So you better check
that the version is as expected right after program startup.

 -- Function: const char * ksba_check_version (const char *REQ_VERSION)
     Check that the the version of the library is at minimum the one
     given as a string in REQ_VERSION and return the actual version
     string of the library; return `NULL' if the condition is not met.
     If `NULL' is passed to this function, no check is done and only the
     version string is returned.  It is a pretty good idea to run this
     function as soon as possible, because it may also initializes some
     subsystems.  In a multi-threaded environment if should be called
     before any more threads are created.

2.3 Building the source
=======================

If you want to compile a source file including the `ksba.h' header
file, you must make sure that the compiler can find it in the directory
hierarchy.  This is accomplished by adding the path to the directory in
which the header file is located to the compiler's include file search
path (via the `-I' option).

   However, the path to the include file is determined at the time the
source is configured.  To solve this problem, `KSBA' ships with a small
helper program `ksba-config' that knows about the path to the include
file and other configuration options.  The options that need to be
added to the compiler invocation at compile time are output by the
`--cflags' option of `ksba-config'.  The following example shows how it
can be used at the command line:

     gcc -c foo.c `ksba-config --cflags`

   Adding the output of `ksba-config --cflags' to the compiler's
command line will ensure that the compiler can find the `ksba.h' header
file.

   A similar problem occurs when linking the program with the library.
Again, the compiler has to find the library files.  For this to work,
the path to the library files has to be added to the library search path
(via the `-L' option).  For this, the option `--libs' of `ksba-config'
can be used.  For convenience, this option also outputs all other
options that are required to link the program with the `KSBA' libraries
(in particular, the `-lksba' option).  The example shows how to link
`foo.o' with the `KSBA' libraries to a program `foo'.

     gcc -o foo foo.o `ksba-config --libs`

   Of course you can also combine both examples to a single command by
specifying both options to `ksba-config':

     gcc -o foo foo.c `ksba-config --cflags --libs`

3 How to work with X.509 certificates.
**************************************

One of the most complex data formats are the X.509 certificates.  KSBA
provides an easy to use interface to handle them.

 -- Data type: ksba_cert_t
     The `ksba_cert_t' type is a handle for an X.509 certificate.

 -- Data type: ksba_sexp_t
     The `ksba_sexp_t' type describes a canonically encoded S-expression
     stored in a memory buffer.  It is alias for `unsigned char *'.
     Note that a length argument is not required because the length of
     such an S-expression is intrinsically available.

3.1 How to create a certificate object
======================================

This section explains how to create a certificate object, initialize it,
copy it and eventually destroy it.

 -- Function: ksba_cert_t ksba_cert_new (void)
     The function `ksba_cert_new' creates a new certificate object and
     returns a handle for it.

     The only reason why this function may fail is an out-of-memory
     condition in which case `NULL' is returned.  You might then get
     the actual error code using `gpg_error_from_errno (errno)'.

 -- Function: void ksba_cert_ref (ksba_cert_t CERT)
     The function `ksba_cert_ref' bumps the reference counter of the
     certificate object up by one.  Thus an extra `ksba_cert_release' is
     required to actually release the memory used for the object.

 -- Function: void ksba_cert_release (ksba_cert_t CERT)
     The function `ksba_cert_release' destroys the certificate object
     with the handle CERT and releases all associated resources.  Due
     to the use of reference counting no actual memory may be released
     if another reference still exists.  It is okay to pass `NULL' to
     the function in which case nothing happens.

 -- Function: gpg_error_t ksba_cert_read_der (ksba_cert_t CERT,
          ksba_reader_t READER)
     Read the next certificate from the READER object and store it in
     the certificate object CERT for future access.  The certificate is
     parsed and rejected if it has any syntactical or semantical error
     (i.e. does not match the ASN.1 description).

     The function returns `0' if the operation was successfully
     performed.  An error code is returned on failure.

 -- Function: gpg_error_t ksba_cert_init_from_mem (ksba_cert_t CERT,
          const void *BUFFER, size_t LENGTH)
     Parse the BUFFER which should contain a DER encoded certificate of
     LENGTH and initialize the certificate object CERT with it.  This
     function is intended as a convenience function to be used when a
     certificate is already available in a internal memory buffer.
     This avoids the extra code needed to setup the reader object.
     Note that CERT must be a valid certificate object.

     The function returns `0' if the operation was successfully
     performed.  An error code is returned on failure.

3.2 How to get the attributes of a certificate
==============================================

The functions in this section allow accessing the attributes of a
certificate in a well defined manner.  An error will be returned if the
certificate object has not yet been initialized by means of
`ksba_cert_read_der' or `ksba_cert_init_from_mem'.

 -- Function: const unsigned char * ksba_cert_get_image
          (ksba_cert_t CERT, size_t *R_LENGTH)
     This function returns a pointer to the DER encoded buffer with the
     raw certificate.  The length of that buffer gets stored at
     R_LENGTH.  This function is useful to export or store the raw
     certificate.

     The function returns `NULL' on error or a pointer to a buffer with
     the raw certificate data.  That pointer is only valid as long as
     the certificate object CERT is valid and has not been
     reinitialized.

 -- Function: gpg_error_t ksba_cert_hash (ksba_cert_t CERT, int WHAT,
          void (*HASHER)(void *, const void *, size_t length),
          void *HASHER_ARG)
     This function feeds the data which is expected to be hashed into
     the supplied function HASHER, where the first argument passed is
     HASHER_ARG, the second the pointer to the data to be hashed and
     the third the length of this data.

     The function returns `0' on success or an error code when something
     goes wrong.  The HASHER function is not expected to return an
     error; instead the caller should setup that function in a way to
     convey encountered errors by means of the HASHER_ARG.  Note that a
     hash function is in general not expected to yield errors anyway.

 -- Function: const char * ksba_cert_get_digest_algo (ksba_cert_t CERT)
     Figure out the the digest algorithm used for the signature and
     return its OID in dotted decimal format.  This function is most
     likely used to setup the hash context before calling
     `ksba_cert_hash'.

     The function returns `NULL' for an error; on success a constant
     string with the OID is returned.  This string is valid as long the
     certificate object is valid.

 -- Function: ksba_sexp_t ksba_cert_get_serial (ksba_cert_t CERT)
     The function returns the serial number of the certificate CERT.
     The serial number is an integer returned as an canonical encoded
     S-expression with just one element.  The caller must free the
     returned value.  The value `NULL' is returned in case of error.

 -- Function: char * ksba_cert_get_issuer (ksba_cert_t CERT, int IDX)
     With IDX given as `0', this function returns the Distinguished
     Name (DN) of the certificate issuer; this usually is the name of a
     certification authority (CA).  The format of the returned string
     is in accordance with RFC-2253.  `NULL' is returned if the DN is
     not available; This is a severe error and actually should have
     been caught by the certificate reading function.

     With IDX greater than zero, the function may be used to enumerate
     alternate issuer names.  The function returns `NULL' when there are
     no more alternate names. Only alternate names recognized by
     `libksba' are returned, others are simply skipped.  The format of
     the returned name is either a RFC-2253 formated string which can be
     detected by checking whether the first character is a letter or
     digit.  RFC-822 conformant email addresses are returned enclosed
     in angle brackets; the opening angle bracket should be used to
     detect this.  Other formats are returned as an S-Expression in
     canonical format, so a opening parenthesis should be used to
     detect this encoding. The name may include binary null characters,
     thus strlen may return a length shorter than actually used.  The
     real length is implicitly given by the structure of the
     S-expression, an extra null is appended for safety reasons.

     The caller must free the returned string using `ksba_free' or
     whatever function has been registered as a replacement.

 -- Function: char * ksba_cert_get_subject (ksba_cert_t CERT, int IDX)
     With IDX given as `0', this function returns the Distinguished
     Name (DN) of the certificate's subject.  The format of the
     returned string is in accordance with RFC-2253.  `NULL' is
     returned if the DN is not available.

     With IDX greater than zero, the function may be used to enumerate
     alternate subject names.  The function returns `NULL' when there
     are no more alternate names. Only alternate names recognized by
     `libksba' are returned, others are simply skipped.  The format of
     the returned name is either a RFC-2253 formated string which can be
     detected by checking whether the first character is a letter or
     digit.  RFC-2822 conform email addresses are returned enclosed in
     angle brackets; the opening angle bracket should be used to detect
     this.  Other formats are returned as an S-Expression in canonical
     format, so a opening parenthesis should be used to detect this
     encoding, the name may include binary null characters, thus strlen
     may return a length shorter than actually used.  The real length
     is implicitly given by the structure of the S-expression, an extra
     null is appended for safety reasons.

     The caller must free the returned string using `ksba_free' or
     whatever function has been registered as a replacement.

 -- Data type: ksba_isotime_t
     Due to problems with the C data type `time_t', which will overflow
     on most 32 bit machines in the year 2038, it was not advisable to
     use this type for referencing times stored in certificates.
     Instead, you should use the `ksba_isotime_t' type, which can
     represent any time since the year 0.

     It is implemented as a buffer of 16 bytes and may be handled like a
     standard string.  It should be initialized to zero (i.e. the first
     byte needs to be 0x00) if it does not hold a valid date.  Date
     values themselves are stored in ISO format and assumed to be
     referenced from UTC.  The string with the date value is always
     guaranteed to be of length 15 and having a format like:
     `"19610711T172059"'.  Note that the `T' is required by ISO rules.

     A simple assignment of these data types is not a good idea.  You
     may use `strcpy' or better a specialized function like:

          void
          copy_time (ksba_isotime_t d, const ksba_isotime_t s)
          {
            if (!*s)
              memset (d, 0, 16);
            else
              strcpy (d, s);
          }

     For reasons of documentation a special function should also be
     used to compare such times:

          int
          cmp_time (const ksba_isotime_t a, const ksba_isotime_t b)
          {
            return strcmp (a, b);
          }

 -- Function: gpg_error_t ksba_cert_get_validity
          (ksba_cert_t CERT, int WHAT, ksba_isotime_t TIMEBUF)
     Return the validity dates from the certificate.  If no value is
     available an empty date object (i.e. a `strlen' will be stored at
     TIMEBUF, otherwise it will receive the date. On failure an error
     code is returned.

     To return the `notBefore' date, the value `0' must be supplied for
     WHAT; `1' yields the `notAfter' value.

 -- Function: ksba_sexp_t ksba_cert_get_public_key (ksba_cert_t CERT)
     [This needs to get written - for now please see libksba/src/cert.c]

 -- Function: ksba_sexp_t ksba_cert_get_sig_val (ksba_cert_t CERT)
     [This needs to get written - for now please see libksba/src/cert.c]

 -- Function: gpg_error_t ksba_cert_get_extension
          (ksba_cert_t CERT, int IDX, char const **R_OID, int *R_CRIT, size_t *R_DEROFF, size_t *R_DERLEN)
     [This needs to get written - for now please see libksba/src/cert.c]

 -- Function: gpg_error_t ksba_cert_is_ca
          (ksba_cert_t CERT, int *R_CA, int *R_PATHLEN)
     Return information on the basicConstraint (2.5.19.19) of CERT.
     R_CA receives true if this is a CA and only in that case R_PATHLEN
     is set to the maximum certification path length or -1 if there is
     no such limitation

 -- Function: gpg_error_t ksba_cert_get_key_usage
          (ksba_cert_t CERT, unsigned int *R_FLAGS)
     Get the key usage flags. The function returns `GPG_ERR_NO_DATA' if
     no key usage is specified. The usage flags are as shown in
     RFC3280, section 4.2.1.3. The key usage flags are represented by a
     bitmask, and you can test each bit using symbolic constants, which
     tells you if that usage is set on the certificate. The constants
     are

    `KSBA_KEYUSAGE_DIGITAL_SIGNATURE'
          Usable for digitalSignature.

    `KSBA_KEYUSAGE_NON_REPUDIATION'
          Usable for nonRepudiation.

    `KSBA_KEYUSAGE_KEY_ENCIPHERMENT'
          Usable for keyEncipherment.

    `KSBA_KEYUSAGE_DATA_ENCIPHERMENT'
          Usable for dataEncipherment.

    `KSBA_KEYUSAGE_KEY_AGREEMENT'
          Usable for for keyAgreement.

    `KSBA_KEYUSAGE_KEY_CERT_SIGN'
          Usable for keyCertSign.

    `KSBA_KEYUSAGE_CRL_SIGN'
          Usable for cRLSign.

    `KSBA_KEYUSAGE_ENCIPHER_ONLY'
          Usable for encipherOnly.

    `KSBA_KEYUSAGE_DECIPHER_ONLY'
          Usable for decipherOnly.

     These are the basic constraints on usage of a certificate. If you
     need to get additional constraints, see
     `ksba_cert_get_ext_key_usages'.

 -- Function: gpg_error_t ksba_cert_get_ext_key_usages
          (ksba_cert_t CERT, char **RESULT)
     Return a string containing the extended usages for the certificate,
     delimited by linefeeds.

 -- Function: gpg_error_t ksba_cert_get_cert_policies
          (ksba_cert_t CERT, char **R_POLICIES)
     Return a string with the certificatePolicies delimited by
     linefeeds.  The return values may be extended to carry more
     information per line, so the caller should only use the first
     white-space delimited token per line.  The function returns
     `GPG_ERR_NO_DATA' when this extension is not used.  Caller must
     free the returned value.

 -- Function: gpg_error_t ksba_cert_get_crl_dist_point
          (ksba_cert_t CERT, int IDX, ksba_name_t *R_DISTPOINT, ksba_name_t *R_ISSUER, unsigned int *R_REASON)
     Return the CRLDistPoints given in the certificate extension of
     certificate CERT.  IDX should be iterated starting from 0 until
     the function returns `GPG_ERR_EOF'.  R_DISTPOINT returns a
     ksba_name_t object with the distribution point name(s); the return
     value may be `NULL' to indicate that this name is not available.
     R_ISSUER returns the CRL issuer; if the returned value is `NULL'
     the caller should assume that the CRL issuer is the same as the
     certificate issuer.  R_REASON returns the reason for the CRL.
     This is a bit encoded value with no bit set if no reason has been
     specified in the certificate.

     The caller may pass `NULL' to any of the pointer arguments if he is
     not interested in this value.  The return values for R_DISTPOINT
     and R_ISSUER must be released by the caller using
     `ksba_name_release'.

 -- Function: gpg_error_t ksba_cert_get_subj_key_id
          (ksba_cert_t CERT, int *R_CRIT, ksba_sexp_t *R_KEYID)
     Return the subjectKeyIdentifier extension as a simple allocated
     S-expression at the address of R_KEYID. 0 is returned on success,
     `GPG_ERR_NO_DATA' if no such extension is available or any other
     error code.  If R_CRIT is not passed as `NULL', the critical flag
     of this is extension is stored at this address.

 -- Function: gpg_error_t ksba_cert_get_auth_key_id
          (ksba_cert_t CERT, ksba_sexp_t *R_KEYID, ksba_name_t *R_NAME, ksba_sexp_t *R_SERIAL)
     Return the authorityKeyIdentifier in R_NAME and R_SERIAL or in
     R_KEYID.  `GPG_ERR_NO_DATA' is returned if no
     authorityKeyIdentifier has been found.  This error code is also
     returned if R_KEYID has been given as NULL and only an
     authorityKeyIdentifier with the keyIdentifier method is available.

 -- Function: gpg_error_t ksba_cert_get_authority_info_access
          (ksba_cert_t CERT, int IDX, char **R_METHOD, ksba_name_t *R_LOCATION)
     Return the authorityInfoAccess attributes. IDX should be iterated
     starting from 0 until this function returns `GPG_ERR_EOF'.
     R_METHOD returns an allocated string with the OID of one item and
     R_LOCATION returns the GeneralName for that OID.  The returned
     values for R_METHOD and R_LOCATION must be released by the caller
     unless the function returned an error; the function will however
     make sure that R_METHOD and R_LOCATION will point to `NULL' if the
     function returns an error.

     See RFC-2459, section 4.2.2.1 for the definition of this attribute.

 -- Function: gpg_error_t ksba_cert_get_subject_info_access
          (ksba_cert_t CERT, int IDX, char **R_METHOD, ksba_name_t *R_LOCATION)
     Return the subjectInfoAccess attributes. IDX should be iterated
     starting from 0 until this function returns `GPG_ERR_EOF'.
     R_METHOD returns an allocated string with the OID of one item and
     R_LOCATION returns the GeneralName for that OID.  The returned
     values for R_METHOD and R_LOCATION must be released by the caller
     unless the function returned an error; the function will however
     make sure that R_METHOD and R_LOCATION will point to `NULL' if the
     function returns an error.

     See RFC-2459, section 4.2.2.2 for the definition of this attribute.

3.3 How to set certificate attributes
=====================================

[This needs to be written.  For example code see newpg/sm/sign.c]

3.4 How to associate other data with a certificate.
===================================================

Certificate objects play a central role in many applications and often
it is desirable to associate other data with the certificate to avoid
wrapping the certificate object into an own object.  `KSBA' provides a
mechanism for this by means of two functions:

 -- Function: gpg_error_t ksba_cert_set_user_data
          (ksba_cert_t CERT, const char *KEY, const void *DATA, size_t DATALEN)
     Stores arbitrary data along with a certificate.  The data is
     expected in the buffer DATA of length DATALEN. It will be stored
     under the string KEY.  If data is already stored under this key it
     will be replaced by the new data. Using `NULL' for DATA will
     effectively delete the data.

     On error (i.e. out of memory) an already existing data object
     stored under KEY may get deleted.

     *Caution:* This function is definitely not thread safe because we
     don't employ any locking mechanisms.

 -- Function: gpg_error_t ksba_cert_get_user_data (ksba_cert_t CERT,
          const char *KEY, void *BUFFER, size_t BUFFERLEN,
          size_t *DATALEN)
     Return user data for certificate CERT stored under the string KEY.
     The caller needs to provide a suitable large BUFFER and the usable
     length of this buffer in BUFFERLEN.  If DATALEN is not `NULL', the
     length of the data stored in BUFFER will be stored there.

     If BUFFER is given as `NULL', BUFFERLEN will be ignored and the
     required length of the buffer will be returned at DATALEN.

     On success 0 is returned.  If no data is stored under the given
     key, `GPG_ERR_NOT_FOUND' is returned.  If the provided buffer is
     too short and BUFFER is not `NULL', `GPG_ERR_BUFFER_TOO_SHORT'
     will be returned.

4 Mastering the Cryptographic Message Syntax
********************************************

The CMS is also known under the name PKCS#7.  Is is a cryptographic
framework for securing data transactions and storage, much like
OpenPGP.  It is heavily based on X.509 semantics and for example used
with the email encryption protocol S/MIME.

4.1 CMS Basics
==============

All operations with the CMS framework require the use of a so called CMS
object which is internally used to keep track of the current state and
to store some meta information.

 -- Data type: ksba_cms_t
     The `ksba_cms_t' type is used for this CMS object.

 -- Data type: ksba_stop_reason_t
     The `ksba_stop_reason_t' type is an enumeration used for
     communication between the phases of a parsing or building process.

 -- Function: ksba_cms_t ksba_cms_new (void)
     This function creates a new CMS object.  The only reason the
     function may fail is an out-of-memory condition in which case
     `NULL' is returned.  It is safe for the caller to translate this
     to the standard error code `GPG_ERR_ENOMEM'.  Any object created
     with this function should be released after use by using
     `ksba_cms_release'.

 -- Function: void ksba_cms_release (ksba_cms_t CMS)
     Release all resources associated with the CMS object.  It is
     perfectly okay to pass `NULL' to this function in which case
     nothing happens.

 -- Function: gpg_error_t ksba_cms_set_reader_writer
          (ksba_cms_t CMS, ksba_reader_t R, ksba_writer_t W)
     About all usages of the CMS framework require some input and
     output data (great surprise!).  To accomplish this in the most
     abstract way, no direct output functions are used - instead
     special reader and writer objects are used instead.  Depending on
     the desired operations either a reader, a writer or both must be
     given.  Associate a reader object with CMS by passing it as R and
     a writer object by passing it as W.  Note that no reference
     counting is done,so make sure that those objects have a lifetime
     at least as long as CMS.

     If you forget to set these objects, you will get an appropriate
     error later when data is actually to be read or written.  The
     function returns zero on success or an error code when invalid
     objects are passed.

4.2 CMS Parser
==============

KSBA includes a versatile CMS parser for encryption (enveloped data)
and digital signing.  The parser is capable of handling arbitrary
amounts of data without requiring much memory.  Well, certain objects
are build in memory because it can be assumed that those objects are
limited in size; e.g. it does not make sense to use a video clip as the
DN despite the fact that the standard does not forbid it.

 -- Function: gpg_error_t ksba_cms_parse
          (ksba_cms_t CMS, ksba_stop_reason_t *R_STOPREASON)
     This is the core function of the parser and commonly used in a
     loop.  The parsing process is divided into several phases to allow
     the user to get information at the right time and prepare for
     further processing.  The caller has to act on certain stop reasons
     which are returned by R_STOPREASON and set up things accordingly;
     KSBA may introduce new stop reasons to let the caller know other
     details; there is no need for the caller to act on every stop
     reason; it should only do so for reasons that the caller
     understands and which are mandatory.  The function will return
     with an error if the caller did not setup things correctly for
     certain stop reasons.

   The use of this function is best explained by an example, leaving
out all error checking.
       do
         {
           ksba_cms_parse (cms, &stopreason);
           if (stopreason == KSBA_SR_BEGIN_DATA)
             {
               get_recipients ();
               decrypt_session_key ();
               setup_bulk_decryption ();
             }
           else if (stopreason == KSBA_SR_END_DATA)
             {
               remove_padding ();
             }
         }
       while (stopreason != KSBA_SR_READY);
   This function assumes that the parsed data is so called `enveloped
data'.

   As CMS provides a common framework for a variety of data formats, it
is probably very useful to check the type of that data very early.
This can be accomplished by hooking into the stop reason
`KSBA_SR_GOT_CONTENT' and retrieving the content using the following
function.

 -- Function: ksba_content_t ksba_cms_get_content_type
          (ksba_cms_t CMS, int WHAT)
     By using a value of `0' for WHAT this function returns the content
     type of the outer container; using `1' does return the content
     type of the enclosed object.

      -- Data type: ksba_content_t
          The `ksba_content_t' type is an enumeration used to describe
          the content of a CMS message.  Here is a list of possible
          values:

         `KSBA_CT_NONE'
               No content type known (value `0')

         `KSBA_CT_DATA'
               The content is plain data, not further interpreted.

         `KSBA_CT_SIGNED_DATA'
               The content is an signed CMS object.  This also includes
               the case of a detached signature where no actual data is
               included in the message.

         `KSBA_CT_ENVELOPED_DATA'
               The content is encrypted using a session key.

         `KSBA_CT_DIGESTED_DATA'
               Not yet supported

         `KSBA_CT_ENCRYPTED_DATA'
               Not yet supported

         `KSBA_CT_AUTH_DATA'
               Not yet supported

 -- Function: const char * ksba_cms_get_content_oid
          (ksba_cms_t CMS, int WHAT)
     Return the object ID of CMS.  This is a constant string valid as
     long as the context is valid and no new parse is started.  This
     function is similar to `ksba_cms_get_content_type' but returns the
     OID actually used in the data.  Depending on the value of WHAT
     different values are returned: Using a value of `0' yields the OID
     of the outer container, a value of `1' yields the OID of the inner
     container if available and the value `2' returns the OID of the
     algorithm used to encrypt the inner container.

5 Certification Revocation Lists
********************************

KSBA also comes with an API to process certification revocation lists.
The API is similar to the CMS one but returns the contents entry by
entry.

6 Certification Requests
************************

When using decentral generated keys, it is necessary to send out special
formated messages so that a CA can generate the certificate.

7 Utilities
***********

A few utility function and objects are available.  Some of them must be
used to support some of the main functions.

7.1 General Names object
========================

This is an object to handle some of the names used in X.509.  We need
this object approach because those names may come as a set and there is
no other clean way to access them.

 -- Data type: ksba_name_t
     The `ksba_name_t' type is an object to represent names sets.

 -- Function: void ksba_name_release (ksba_name_t NAME)
     This function releases the object NAME.  Passing `NULL' is allowed.

 -- Function: const char * ksba_name_enum (ksba_name_t NAME, int IDX)
     By iterating IDX up starting with 0, this function returns all
     General Names stored in NAME.  The format of the returned name is
     either a RFC-2253 formated one which can be detected by checking
     whether the first character is letter or a digit.  RFC 2822
     conformant email addresses are returned enclosed in angle
     brackets, the opening angle bracket should be used to detect this.
     Other formats are returned as an S-Expression in canonical
     format, so an opening parenthesis may be used to detect this
     encoding, in this case the name may include binary null
     characters, so strlen might return a length shorter than actually
     used, the real length is implicitly given by the structure of the
     S-Exp, an extra null is appended for safety reasons.  One common
     format return is a Universal Resource Identifier which has the
     S-expression: `(uri <urivalue>)'.

     The returned string has the same lifetime as NAME.

 -- Function: char * ksba_name_get_uri (ksba_name_t NAME, int IDX)
     Convenience function to return names representing an URI.  Caller
     must free the returned value.  Note that this function should not
     be used to enumerate the names.

     Here is an example on how you can use this function to enumerate
     all URIs:

          void
          print_names (ksba_name_t name)
          {
            int idx;
            const char *s;

            for (idx=0; (s = ksba_name_enum (name, idx)); idx++)
              {
                char *p = ksba_name_get_uri (name, idx);
                if (p)
                  {
                     puts (p);
                     ksba_free (p);
                  }
              }
          }

7.2 Object Identifier helpers
=============================

[This needs to get written - for now please see libksba/src/oids.c]

7.3 Distinguished Name helpers
==============================

These are helper functions for the so called distinguished names.  They
are used for example as the issuer and subject name.

 -- Function: gpg_error_t ksba_dn_teststr (const char *STRING, int SEQ,
          size_t *RERROFF, size_t *RERRLEN)
     Assuming that STRING contains an RFC-2253 encoded string, test
     whether this string may be passed as a valid DN to libksba.  On
     success the functions returns `0'.  On error the function returns
     an error code and stores the offset of the erroneous part at
     RERROFF. RERRLEN will then receive the length of the erroneous
     part.

     This function is mostly useful to test whether a certain component
     label is supported. SEQ should be passed as `0' for now.  Any of
     RERROFF and RERRLEN may be passed as NULL if the caller is not
     interested at this value.

   gpg_error_t ksba_dn_str2der (const char *string, void **rder, size_t
*rderlen);

   gpg_error_t ksba_dn_der2str (const void *der, size_t derlen, char
**r_string);

8 Error Handling
****************

Most functions in `KSBA' will return an error if they fail.  For this
reason, the application should always catch the error condition and
take appropriate measures, for example by releasing the resources and
passing the error up to the caller, or by displaying a descriptive
message to the user and canceling the operation.

   Some error values do not indicate a system error or an error in the
operation, but the reasonable result of an operation.  For example, if
you try to access optional attributes of a certificate that are not
present, you get an appropriate error message.  Some error values have
specific meanings if returned by a specific function.  Such cases are
described in the documentation of those functions.

   All error codes are defined by the library `libgpg-error'.  See
there for ways to check the error values and print descriptive strings.
Please be aware that you can't check directly against an error code
but have to do it like this:

       err = ksba_foo ();
       if (gpg_err_code (err) == GPG_ERR_EOF)
         okay = 1;

   The only exception is that success (i.e. no error) is defined to be
`0'; thus you may directly test for success like:

       if (!ksba_foo ())
         okay = 1;

Appendix A Component Labels
***************************

RFC-2253 defines the following table with string representations of name
components:

Label          Component            OID

C              countryName          2.5.4.6
CN             commonName           2.5.4.3
DC             domainComponent      0.9.2342.19200300.100.1.25
L              localityName         2.5.4.7
O              organizationName     2.5.4.10
OU             organizationalUnit   2.5.4.11
ST             stateOrProvince      2.5.4.8
STREET         streetAddress        2.5.4.9
UID            userid               0.9.2342.19200300.100.1.1

   They are used internally for converting a DN into its string
representation; components not listed in this table will be represented
by their OID.

   For the other direction, i.e. creating a DN from the string
representation, KSBA recognizes the following extra labels:

Label          Component            OID

ADDR           postalAddress        2.5.4.16
BC             businessCategory     2.5.4.15
D              description          2.5.4.13
EMAIL          emailAddress         1.2.840.113549.1.9.1
GN             givenName            2.5.4.42
POSTALCODE     postalCode           2.5.4.17
PSEUDO         pseudonym            2.5.4.65
SERIALNUMBER   serialNumber         2.5.4.5
SN             surname              2.5.4.4
T              title                2.5.4.12

Appendix B GNU GENERAL PUBLIC LICENSE
*************************************

                         Version 2, June 1991

     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

B.0.1 Preamble
--------------

The licenses for most software are designed to take away your freedom
to share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it in
new free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
  1. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program",
     below, refers to any such program or work, and a "work based on
     the Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification".)  Each
     licensee is addressed as "you".

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  2. You may copy and distribute verbatim copies of the Program's
     source code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  3. You may modify your copy or copies of the Program or any portion
     of it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program
          or any part thereof, to be licensed as a whole at no charge
          to all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not
     apply to those sections when you distribute them as separate
     works.  But when you distribute the same sections as part of a
     whole which is a work based on the Program, the distribution of
     the whole must be on the terms of this License, whose permissions
     for other licensees extend to the entire whole, and thus to each
     and every part regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on
     a volume of a storage or distribution medium does not bring the
     other work under the scope of this License.

  4. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either
     source or binary form) with the major components (compiler,
     kernel, and so on) of the operating system on which the executable
     runs, unless that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  5. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

  6. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this
     License to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  7. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program
     subject to these terms and conditions.  You may not impose any
     further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties to this License.

  8. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who
     receive copies directly or indirectly through you, then the only
     way you could satisfy both it and this License would be to refrain
     entirely from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  9. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

 10. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies
     to it and "any later version", you have the option of following
     the terms and conditions either of that version or of any later
     version published by the Free Software Foundation.  If the Program
     does not specify a version number of this License, you may choose
     any version ever published by the Free Software Foundation.

 11. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted
     by the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                                NO WARRANTY
 12. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
     WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
     NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
     QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
     PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
     SERVICING, REPAIR OR CORRECTION.

 13. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License along
     with this program; if not, write to the Free Software Foundation, Inc.,
     51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 19YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands `show w' and `show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than `show w' and `show
c'; they could even be mouse-clicks or menu items--whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.